## scalene 1.4.1

=== Makefile ===
LIBNAME = scalene
PYTHON = python3
PYTHON_SOURCES = scalene/[a-z]*.py
C_SOURCES = src/source/get_line_atomic.cpp src/include/*.h* # src/source/libscalene.cpp 

CXXFLAGS = /Ox /DNDEBUG /std:c++14 /Zi
CXX = cl

MAIN_INCLUDES  = -Isrc -Isrc/include
INCLUDES = $(MAIN_INCLUDES) -Ivendor/Heap-Layers -Ivendor/Heap-Layers/wrappers -Ivendor/Heap-Layers/utility -Ivendor/printf

LIBFILE = lib$(LIBNAME).dll
WRAPPER = # vendor/Heap-Layers/wrappers/gnuwrapper.cpp

SRC = src/source/lib$(LIBNAME).cpp $(WRAPPER) vendor/printf/printf.cpp

all:  # vendor-deps $(SRC) $(OTHER_DEPS)
# $(CXX) $(CXXFLAGS) $(INCLUDES) $(SRC) /o $(LIBFILE)

mypy:
	-mypy $(PYTHON_SOURCES)

format: black clang-format

clang-format:
	-clang-format -i $(C_SOURCES) --style=google

black:
	-black -l 79 $(PYTHON_SOURCES)

vendor/Heap-Layers:
	cd vendor && git clone https://github.com/emeryberger/Heap-Layers

vendor/printf/printf.cpp:
	cd vendor && git clone https://github.com/mpaland/printf
	cd vendor\printf && copy printf.c printf.cpp

vendor-deps: clear-vendor-dirs vendor/Heap-Layers vendor/printf/printf.cpp

clear-vendor-dirs:
	if exist vendor\ (rmdir /Q /S vendor)
	mkdir vendor

pkg: vendor/Heap-Layers vendor/printf/printf.cpp
	-rm -rf dist build *egg-info
	$(PYTHON) setup.py sdist bdist_wheel

upload: pkg # to pypi
	$(PYTHON) -m twine upload dist/*

=== requirements.txt ===
cloudpickle==1.6.0
ipython==7.19.0
lxml==4.6.5
numpy~=1.21.2
packaging==20.9
pynvml==11.0.0
pyperf==2.0.0
rich==10.7.0
setuptools~=57.0.0
pip~=21.1.2
wheel~=0.36.1

## scalene 0.7.5

=== debian/changelog ===
scalene (0.7.5-2) unstable; urgency=medium

  * Team upload.
  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use canonical URL in Vcs-Git.

  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Sergio Durigan Junior ]
  * d/control: Bump debhelper-compat to 13.
  * d/control: Bump Standards-Version to 4.5.1.
  * d/control: Set Rules-Requires-Root: no.

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sun, 20 Dec 2020 18:55:01 -0500

scalene (0.7.5-1) unstable; urgency=medium

  * Initial release (Closes: #951348)

 -- Emmanuel Arias <eamanu@yaerobi.com>  Sat, 15 Feb 2020 22:27:08 -0300

=== debian/control ===
Source: scalene
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Emmanuel Arias <eamanu@yaerobi.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-setuptools,
               python3-all,
               python3-numpy,
Standards-Version: 4.5.1
Homepage: https://github.com/emeryberger/scalene
Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene
Vcs-Git: https://salsa.debian.org/python-team/packages/scalene.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-scalene
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: high-performance CPU and memory profiler for Python (Python 3)
 scalene is a high-performance cpu *and* memory profiler for Python that does
 a few things that other Python profilers do not and cannot do.  It runs
 orders of magnitude faster than other profilers while delivering far more
 detailed information.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export PYBUILD_NAME=scalene

%:
	dh $@ --with python3 --buildsystem=pybuild


override_dh_auto_test:
	# pass
	# pyperf must be package to run test

## scalene 1.4.1

=== debian/changelog ===
scalene (1.4.1-1) unstable; urgency=medium

  [ Adam Cecile ]
  * Package is now arch any instead of all because it contains built
   libraries for better profiling.
  * Command scalene is now provided (Closes: #983655).
  * Update debian/copyright to add statements for vendor folder.
  * Add runtime dependencies as build dependencies so help2man can run
    scalene command.
  * Generate scalene manpage using help2man.
  * Prepare packaging to run unittest but still not enabled yet (pyperf
    needed + other errors).
  * Add pynvml (NVIDIA GPU profiling) recommends, contrib package so no
    strict dependency.
  * Patch code to avoid strict dependency on pynvml.
  * Patch code to load liscalene.so after renaming with Python ABI suffix.

  [ Emmanuel Arias ]
  * New upstream release.
  * wrap-and-sort.
  * d/control: Add python3-wheel as Build Depends.
  * d/rules: Enable the bindnow hardening flag.
  * d/rules: Provide a name to the manual generated by help2man.
  * d/rules: Install *.so shared libraries in /usr/lib/scalene/lib.
  * d/control: Add python3-pip as Build Dependency.
  * d/copyright: Remove vendor/Hoard/ license entry. Upstream not longer
    package it.
  * d/control: Add pyhton3-ipython as Recommends for binary-package.
  * d/copyright: Update copyright year for debian/* files.
  * d/copyright: Reformat file.
  * d/python3-scalene.docs: Add /vendor/Heap-Layers/NOTICE file in the binary
    package.
  * remove temporal file.

  [ Nilesh Patra ]
  * Add patch and remove B-D on python3-pip
  * d/control: Bump Standards-Version to 4.6.0 (No changes needed)

 -- Emmanuel Arias <eamanu@yaerobi.com>  Sat, 12 Mar 2022 19:41:38 +0530

=== debian/control ===
Source: scalene
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
Build-Depends: debhelper-compat (= 13),
               dh-python,
               help2man,
               python3-all-dev,
               python3-cloudpickle,
               python3-numpy,
               python3-packaging,
               python3-pytest <!nocheck>,
               python3-rich,
               python3-setuptools,
               python3-setuptools-scm,
               python3-wheel,
Standards-Version: 4.6.0
Homepage: https://github.com/emeryberger/scalene
Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene
Vcs-Git: https://salsa.debian.org/python-team/packages/scalene.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-scalene
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Recommends: python3-ipython,
            python3-pynvml,
Description: high-performance CPU and memory profiler for Python (Python 3)
 scalene is a high-performance cpu *and* memory profiler for Python that does
 a few things that other Python profilers do not and cannot do.  It runs
 orders of magnitude faster than other profilers while delivering far more
 detailed information.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME=scalene
export PYBUILD_TEST_ARGS=-v
export PYBUILD_BEFORE_TEST=cp -rv {dir}/test {build_dir}
export PYBUILD_AFTER_TEST=rm -rfv {build_dir}/test
export PYBUILD_AFTER_BUILD=cd {build_dir}; \
  help2man -N -n 'Memory Profiler for Python' python3 -m $(PYBUILD_NAME) \
    --no-info \
    --section 1 \
    --version-string '$(DEB_VERSION_UPSTREAM)' \
    > $(CURDIR)/$(PYBUILD_NAME).1
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DESTDIR=$(CURDIR)/debian/python3-scalene
PYVERS := $(shell py3versions -sv)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
	# pass
	# pyperf must be package to run test


execute_after_dh_install:
	set -e; for pyver in $(PYVERS); do \
		abitag=.$$(python$$pyver -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene$$abitag.so; \
		mkdir -p $(DESTDIR)/usr/lib/scalene/lib; \
		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/*.so $(DESTDIR)/usr/lib/scalene/lib/; \
	done

## scalene 1.5.16

=== requirements.txt ===
cloudpickle==1.6.0
Cython>=0.29.28
git+https://github.com/plasma-umass/crdp.git#egg=crdp
ipython==7.31.1
Jinja2==3.0.3
lxml==4.9.1
packaging==20.9
pyperf==2.0.0
rich>=10.7.0
setuptools~=57.0.0
pip~=21.1.2
pynvml~=11.0.0
wheel~=0.36.1

=== debian/changelog ===
scalene (1.5.16-1) unstable; urgency=medium

  * New upstream version (Closes: #1025237, #1023633).
  * d/patches: Update patches according to upstream changes.
  * d/control: Bump Standards-Version to 4.6.1.1 (from 4.6.0; no further
    changes).
  * d/copyright: Update the Source upstream link.
  * d/control: Update Homepage upstream link.
  * d/copyright: Update the upstream name and contact email in the file.
  * d/python3-scalene.install: install scalene-gui in
    /usr/share/python3-scalene/.
    - d/patches: Add 0005-Point-to-the-debianize-scalene-gui-path.patch to
    redirect correctly the scalene-gui path.
    - d/control: Add libjs-bootstrap4 and libjs-jquery as dependency of the
    package. These are used by the scalene-gui.
  * d/patches: Add 0004-Remove-links-to-external-resource.patch patch to
    remove links for external libs.
  * d/rules: Fix where the *.so files are installed. Now they are living in
    /usr/lib/python*/dist-packages/scalene/.
    - Add Debian SOABI name to crdp and get_line_atomic extensions.
  * d/source/lintian-overrides: Override source-is-missing,
    very-long-line-length-in-source-file and
    source-contains-prebuilt-javascript-object they are because scalene-gui
    contains some js files.
    - python3-scalene.lintian-overrides: Override privacy-breach-generic, this
    is because scalene-gui use vega-embed and vega-lite and they are not in
    Debian yet.
  * d/patches/0006-Add-hardening-flags-in-the-build.patch: Add patch to use
    CXXFLAGS, CPPFLAGS and LDFLAGS in build to solve hardening issues.
    - d/rules: Change DEB_BUILD_MAINT_OPTIONS to hardening=+all from
    hardening=+bindnow.
  * d/control: Add cython3 and python3-jinja2 as Build Depends.
    - Run wrap-and-sort.
  * d/control: Remove trivial autopkgtest-pkg-python.
  * d/tests: Add autopkgtest.
  * d/copyright: Add more files and its copyright notes.
    - Use expat License instead of MIT license.
    - Add crdp vendored extension to copyright.

 -- Emmanuel Arias <eamanu@yaerobi.com>  Mon, 26 Dec 2022 09:33:26 -0300

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,13 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cython3,
+               debhelper-compat (= 13),
                dh-python,
                help2man,
                python3-all-dev,
                python3-cloudpickle,
+               python3-jinja2,
                python3-numpy,
                python3-packaging,
                python3-pytest <!nocheck>,
@@ -15,16 +17,17 @@
                python3-setuptools,
                python3-setuptools-scm,
                python3-wheel,
-Standards-Version: 4.6.0
-Homepage: https://github.com/emeryberger/scalene
+Standards-Version: 4.6.1.1
+Homepage: https://github.com/plasma-umass/scalene
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene
 Vcs-Git: https://salsa.debian.org/python-team/packages/scalene.git
-Testsuite: autopkgtest-pkg-python
 Rules-Requires-Root: no
 
 Package: python3-scalene
 Architecture: any
-Depends: ${misc:Depends},
+Depends: libjs-bootstrap4,
+         libjs-jquery,
+         ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends},
 Recommends: python3-ipython,

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
     --section 1 \
     --version-string '$(DEB_VERSION_UPSTREAM)' \
     > $(CURDIR)/$(PYBUILD_NAME).1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DESTDIR=$(CURDIR)/debian/python3-scalene
 PYVERS := $(shell py3versions -sv)
 
@@ -29,6 +29,6 @@
 	set -e; for pyver in $(PYVERS); do \
 		abitag=.$$(python$$pyver -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
 		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene$$abitag.so; \
-		mkdir -p $(DESTDIR)/usr/lib/scalene/lib; \
-		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/*.so $(DESTDIR)/usr/lib/scalene/lib/; \
+		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/crdp.abi3.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/crdp$$abitag.so; \
+		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/get_line_atomic.abi3.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/get_line_atomic$$abitag.so; \
 	done

## scalene 1.5.34

=== requirements.txt ===
astunparse>=1.6.3; python_version < '3.9'
cloudpickle==2.2.1
Cython>=0.29.28
git+https://github.com/plasma-umass/crdp.git#egg=crdp
ipython>=8.10
Jinja2==3.0.3
lxml==5.1.0
packaging==20.9
psutil>=5.9.2
pyperf==2.0.0
rich>=10.7.0
setuptools>=65.5.1
pynvml~=11.0.0
wheel~=0.38.1

=== vendor/crdp/requirements.txt ===
Cython>=0.29.28

=== debian/changelog ===
scalene (1.5.34-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 18:04:26 +0000

scalene (1.5.34-1) unstable; urgency=medium

  * New upstream version.
  * d/control: Update my contact information.
  * d/patches/0005-Point-to-the-debianize-scalene-gui-path.patch: Update patch
    according to the new upstream release source code.

 -- Emmanuel Arias <eamanu@debian.org>  Tue, 20 Feb 2024 20:32:26 -0300

scalene (1.5.31.1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version (Closes: #1056886, #1037852, #1055725).
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Update lintian override info format in d/source/lintian-overrides on line 5.

  [ Emmanuel Arias ]
  * d/patches/0006-Remove-vendor-deps-target-call.patch: Add patches to remove
    the target "vendor-deps" that clone the vedors dependencies. The upstream
    code from pypi.debian.net already include them.
  * d/patches/0001-Load-libscalene-so-with-Python-ABI-suffix: Update patch to
    use importlib module to Debianize the libscalene name instead of use imp
    module.

 -- Emmanuel Arias <eamanu@debian.org>  Sat, 03 Feb 2024 17:51:57 -0300

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: python
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
-Uploaders: Emmanuel Arias <eamanu@yaerobi.com>,
+Uploaders: Emmanuel Arias <eamanu@debian.org>,
 Build-Depends: cython3,
                debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                help2man,
                python3-all-dev,
                python3-cloudpickle,
@@ -17,7 +17,7 @@
                python3-setuptools,
                python3-setuptools-scm,
                python3-wheel,
-Standards-Version: 4.6.1.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/plasma-umass/scalene
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene
 Vcs-Git: https://salsa.debian.org/python-team/packages/scalene.git

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 PYVERS := $(shell py3versions -sv)
 
 %:
-	dh $@ --with python3 --buildsystem=pybuild
+	dh $@ --buildsystem=pybuild
 
 override_dh_auto_test:
 	# pass

## scalene 1.5.40

=== debian/changelog ===
scalene (1.5.40-1) unstable; urgency=medium

  * New upstream version.

 -- Emmanuel Arias <eamanu@debian.org>  Sun, 28 Apr 2024 18:08:57 -0300

scalene (1.5.39-1) unstable; urgency=medium

  * New upstream version.
  * d/patches: Update patches according to upstream source code:
    - 0000-No-strict-dependency-on-pynvml
    - 0005-Point-to-the-debianize-scalene-gui-path.patch
    - 0006-Add-hardening-flags-in-the-build.patch
    - 0006-Remove-vendor-deps-target-call.patch
  * d/python3-scalene.install: Install scalene-gui in
    /usr/lib/python3/dist-package instead of /usr/share/python3-scalene.

 -- Emmanuel Arias <eamanu@debian.org>  Tue, 23 Apr 2024 11:48:15 -0300

## scalene 1.5.41

=== requirements.txt ===
--- 
+++ 
@@ -10,5 +10,5 @@
 pyperf==2.0.0
 rich>=10.7.0
 setuptools>=65.5.1
-pynvml~=11.0.0
+pynvml>=11.0,<=11.5
 wheel~=0.38.1

=== debian/changelog ===
scalene (1.5.41-1) unstable; urgency=medium

  * New upstream version.
  * d/control: Add pybuild-plugin-pyproject as Build Dependency.
  * d/control: Bump Standards-Version to 4.7.0 (from 4.6.2; no further
    changes needed).

 -- Emmanuel Arias <eamanu@debian.org>  Fri, 10 May 2024 20:44:05 -0300

## scalene 1.5.43.2

=== requirements.txt ===
--- 
+++ 
@@ -9,6 +9,6 @@
 psutil>=5.9.2
 pyperf==2.0.0
 rich>=10.7.0
-setuptools>=65.5.1
-pynvml>=11.0,<=11.5
+setuptools>=65.5.1,<71.0  # Pin to setuptools<71.0 to avoid this bug: https://github.com/pypa/setuptools/issues/4496
+nvidia-ml-py>=12.555.43; platform_system !='Darwin'
 wheel~=0.38.1

=== debian/changelog ===
scalene (1.5.43.2-1) unstable; urgency=medium

  * New upstream version.
  * d/patches/0000-No-strict-dependency-on-pynvml: Update patch acording to
    new upstream release source code.
  * d/copyright: Remove vendor/crdp/* from copyright entry.
  * d/rules: Stop install crdp.abi3.so.

 -- Emmanuel Arias <eamanu@debian.org>  Fri, 09 Aug 2024 21:29:29 -0300

## scalene 1.5.44.1

=== debian/changelog ===
scalene (1.5.44.1-1) unstable; urgency=medium

  * New upstream version.
  * d/patches/0005-Point-to-the-debianize-scalene-gui-path.patch: Refresh
    patch.

 -- Emmanuel Arias <eamanu@debian.org>  Fri, 23 Aug 2024 16:28:35 -0300

## scalene 1.5.45

=== requirements.txt ===
astunparse>=1.6.3; python_version < '3.9'
cloudpickle==2.2.1
Cython>=0.29.28
git+https://github.com/plasma-umass/crdp.git#egg=crdp
ipython>=8.10
Jinja2==3.0.3
lxml==5.1.0
packaging>=24
psutil>=5.9.2
pyperf==2.0.0
rich>=10.7.0
setuptools>=65.5.1
nvidia-ml-py>=12.555.43; platform_system !='Darwin'
wheel>=0.43.0
# Per https://github.com/pypa/setuptools/issues/4483#issuecomment-2236528158
ordered-set>=3.1.1
more_itertools>=8.8
jaraco.text>=3.7
importlib_resources>=5.10.2
importlib_metadata>=6
tomli>=2.0.1
platformdirs >= 2.6.2

=== vendor/printf/Makefile ===
# ------------------------------------------------------------------------------
# 
# Generic Makefile
#
# Copyright Marco Paland 2007 - 2017
# Distributed under the MIT License
#
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
# Paths
# ------------------------------------------------------------------------------
PATH_TOOLS_CC        = /usr/bin/
PATH_TOOLS_CC_LIB    = /usr/lib/
PATH_TOOLS_UTIL      = 

PATH_BIN       = bin
PATH_TMP       = tmp
PATH_NUL       = /dev/null
PATH_OBJ       = $(PATH_TMP)/obj
PATH_LST       = $(PATH_TMP)/lst
PATH_ERR       = $(PATH_TMP)/err
PATH_PRE       = $(PATH_TMP)/pre
PATH_COV       = $(PATH_TMP)/cov


# ------------------------------------------------------------------------------
# Application to build
# ------------------------------------------------------------------------------

APP = test_suite


# -----------------------------------------------------------------------------
# Project file list
# Format is:
# FILES_PRJ  = file1                        \
#              foo/file2                    \
#              bar/file3
# -----------------------------------------------------------------------------

FILES_PRJ  = test/test_suite


# ------------------------------------------------------------------------------
# Additional include files and compiler defines
# Format is:
# C_INCLUDES = -Iinclude_path1                 \
#              -Iinclude_path2                 \
#              -Iinclude_path3                 \
# ------------------------------------------------------------------------------

C_INCLUDES = 

C_DEFINES  = 


# ------------------------------------------------------------------------------
# The target name and location
# ------------------------------------------------------------------------------
TRG = $(PATH_BIN)/$(APP)


# ------------------------------------------------------------------------------
# object files
# ------------------------------------------------------------------------------
FILES_TMP   = $(FILES_PRJ)
FILES_O     = $(addsuffix .o, $(FILES_TMP))


# ------------------------------------------------------------------------------
# VPATH definition
#
# VPATH is required for the maker to find the C-/ASM-Source files.
# Extract the directory/module names from the file list with the dir
# command and remove the duplicated directory names with the sort command.
# FILES_PRJ is listed first to make sure that the source files in the project
# directory are searched first.
# ------------------------------------------------------------------------------
VPATH := $(sort $(dir $(FILES_TMP)))


# ------------------------------------------------------------------------------
# Development tools
# ------------------------------------------------------------------------------
AR        = $(PATH_TOOLS_CC)ar
AS        = $(PATH_TOOLS_CC)g++
CC        = $(PATH_TOOLS_CC)g++
CL        = $(PATH_TOOLS_CC)g++
NM        = $(PATH_TOOLS_CC)nm
GCOV      = $(PATH_TOOLS_CC)gcov
OBJDUMP   = $(PATH_TOOLS_CC)objdump
OBJCOPY   = $(PATH_TOOLS_CC)objcopy
READELF   = $(PATH_TOOLS_CC)readelf
SIZE      = $(PATH_TOOLS_CC)size

ECHO      = $(PATH_TOOLS_UTIL)echo
MAKE      = $(PATH_TOOLS_UTIL)make
MKDIR     = $(PATH_TOOLS_UTIL)mkdir
RM        = $(PATH_TOOLS_UTIL)rm
SED       = $(PATH_TOOLS_UTIL)sed


# ------------------------------------------------------------------------------
# Compiler flags for the target architecture
# ------------------------------------------------------------------------------

GCCFLAGS      = $(C_INCLUDES)                     \
                $(C_DEFINES)                      \
                -std=c++11                        \
                -g                                \
                -Wall                             \
                -pedantic                         \
                -Wmain                            \
                -Wundef                           \
                -Wsign-conversion                 \
                -Wuninitialized                   \
                -Wshadow                          \
                -Wunreachable-code                \
                -Wswitch-default                  \
                -Wswitch                          \
                -Wcast-align                      \
                -Wmissing-include-dirs            \
                -Winit-self                       \
                -Wdouble-promotion                \
                -gdwarf-2                         \
                -fno-exceptions                   \
                -O2                               \
                -ffunction-sections               \
                -ffat-lto-objects                 \
                -fdata-sections                   \
                -fverbose-asm                     \
                -Wextra                           \
                -Wunused-parameter                \
                -Wfloat-equal

CFLAGS        = $(GCCFLAGS)                       \
                -Wunsuffixed-float-constants      \
                -x c                              \
                -std=c99

CPPFLAGS      = $(GCCFLAGS)                       \
                -x c++                            \
                -fno-rtti                         \
                -fstrict-enums                    \
                -fno-use-cxa-atexit               \
                -fno-use-cxa-get-exception-ptr    \
                -fno-nonansi-builtins             \
                -fno-threadsafe-statics           \
                -fno-enforce-eh-specs             \
                -ftemplate-depth-64               \
                -fexceptions

AFLAGS        = $(GCCFLAGS)                       \
                -x assembler

LFLAGS        = $(GCCFLAGS)                       \
                -x none                           \
                -Wl,--gc-sections

# ------------------------------------------------------------------------------
# Targets
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
# Main-Dependencies (app: all)
# ------------------------------------------------------------------------------
.PHONY: all
all: clean_prj $(TRG) $(TRG)_nm.txt


# ------------------------------------------------------------------------------
# Main-Dependencies (app: rebuild)
# ------------------------------------------------------------------------------
.PHONY: rebuild
rebuild: clean $(TRG) $(TRG)_nm.txt


# ------------------------------------------------------------------------------
# clean project
# ------------------------------------------------------------------------------
.PHONY: clean_prj
clean_prj:
	@-$(ECHO) +++ cleaning project
	@-$(RM) -rf $(PATH_BIN) 2> $(PATH_NUL)
	@-$(MKDIR) -p $(PATH_BIN)
	@-$(MKDIR) -p $(PATH_OBJ)
	@-$(MKDIR) -p $(PATH_ERR)
	@-$(MKDIR) -p $(PATH_LST)
	@-$(MKDIR) -p $(PATH_PRE)
	@-$(MKDIR) -p $(PATH_COV)


# ------------------------------------------------------------------------------
# clean all
# ------------------------------------------------------------------------------
.PHONY: clean
clean:
	@-$(ECHO) +++ cleaning all
	@-$(RM) -rf $(PATH_BIN) 2> $(PATH_NUL)
	@-$(RM) -rf $(PATH_TMP) 2> $(PATH_NUL)
	@-$(MKDIR) -p $(PATH_BIN)
	@-$(MKDIR) -p $(PATH_OBJ)
	@-$(MKDIR) -p $(PATH_ERR)
	@-$(MKDIR) -p $(PATH_LST)
	@-$(MKDIR) -p $(PATH_COV)


# ------------------------------------------------------------------------------
# print the GNUmake version and the compiler version
# ------------------------------------------------------------------------------
.PHONY: version
version:
  # Print the GNU make version and the compiler version
	@$(ECHO) GNUmake version:
	@$(MAKE) --version
	@$(ECHO) GCC version:
	@$(CL) -v


# ------------------------------------------------------------------------------
# Rules
# ------------------------------------------------------------------------------

# ------------------------------------------------------------------------------
# Link/locate application
# ------------------------------------------------------------------------------
$(TRG) : $(FILES_O)
	@-$(ECHO) +++ linkink application to generate: $(TRG)
	@-$(CL) $(LFLAGS) -L. -lc $(PATH_OBJ)/*.o -Wl,-Map,$(TRG).map -o $(TRG)
  # profiling
	@-$(CL) $(LFLAGS) -L. -lc $(PATH_COV)/*.o --coverage -o $(PATH_COV)/$(APP)


# ------------------------------------------------------------------------------
# parse the object files to obtain symbol information, and create a size summary
# ------------------------------------------------------------------------------
$(TRG)_nm.txt : $(TRG)
	@-$(ECHO) +++ parsing symbols with nm to generate: $(TRG)_nm.txt
	@-$(NM) --numeric-sort --print-size $(TRG) > $(TRG)_nm.txt
	@-$(ECHO) +++ demangling symbols with c++filt to generate: $(TRG)_cppfilt.txt
	@-$(NM) --numeric-sort --print-size $(TRG) | $(CPPFILT) > $(TRG)_cppfilt.txt
	@-$(ECHO) +++ creating size summary table with size to generate: $(TRG)_size.txt
	@-$(SIZE) -A -t $(TRG) > $(TRG)_size.txt


%.o : %.cpp
	@$(ECHO) +++ compile: $<
  # Compile the source file
  # ...and Reformat (using sed) any possible error/warning messages for the VisualStudio(R) output window
  # ...and Create an assembly listing using objdump
  # ...and Generate a dependency file (using the -MM flag)
	@-$(CL) $(CPPFLAGS) $< -E -o $(PATH_PRE)/$(basename $(@F)).pre
	@-$(CL) $(CPPFLAGS) $< -c -o $(PATH_OBJ)/$(basename $(@F)).o 2> $(PATH_ERR)/$(basename $(@F)).err
	@-$(SED) -e 's|.h:\([0-9]*\),|.h(\1) :|' -e 's|:\([0-9]*\):|(\1) :|' $(PATH_ERR)/$(basename $(@F)).err
	@-$(OBJDUMP) --disassemble --line-numbers -S $(PATH_OBJ)/$(basename $(@F)).o > $(PATH_LST)/$(basename $(@F)).lst
	@-$(CL) $(CPPFLAGS) $< -MM > $(PATH_OBJ)/$(basename $(@F)).d
  # profiling
	@-$(CL) $(CPPFLAGS) -O0 --coverage $< -c -o $(PATH_COV)/$(basename $(@F)).o 2> $(PATH_NUL)

%.o : %.c
	@$(ECHO) +++ compile: $<
  # Compile the source file
  # ...and Reformat (using sed) any possible error/warning messages for the VisualStudio(R) output window
  # ...and Create an assembly listing using objdump
  # ...and Generate a dependency file (using the -MM flag)
	@-$(CL) $(CFLAGS) $< -E -o $(PATH_PRE)/$(basename $(@F)).pre
	@-$(CC) $(CFLAGS) $< -c -o $(PATH_OBJ)/$(basename $(@F)).o 2> $(PATH_ERR)/$(basename $(@F)).err
	@-$(SED) -e 's|.h:\([0-9]*\),|.h(\1) :|' -e 's|:\([0-9]*\):|(\1) :|' $(PATH_ERR)/$(basename $(@F)).err
	@-$(OBJDUMP) -S $(PATH_OBJ)/$(basename $(@F)).o > $(PATH_LST)/$(basename $(@F)).lst
	@-$(CC) $(CFLAGS) $< -MM > $(PATH_OBJ)/$(basename $(@F)).d

=== debian/changelog ===
scalene (1.5.45-2) unstable; urgency=medium

  * d/patches/remove-dependency-on-astunparse.patch: Add patch to remove
   dependency on astunparse.

 -- Emmanuel Arias <eamanu@debian.org>  Sat, 19 Oct 2024 22:55:57 -0300

scalene (1.5.45-1) unstable; urgency=medium

  * New upstream version.
  * d/patches/0001-Load-libscalene-so-with-Python-ABI-suffix: Update patch
    according to new upstream release.

 -- Emmanuel Arias <eamanu@debian.org>  Thu, 03 Oct 2024 16:40:17 -0300

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                debhelper-compat (= 13),
                dh-sequence-python3,
                help2man,
+               pybuild-plugin-pyproject,
                python3-all-dev,
                python3-cloudpickle,
                python3-jinja2,
@@ -17,7 +18,7 @@
                python3-setuptools,
                python3-setuptools-scm,
                python3-wheel,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/plasma-umass/scalene
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene
 Vcs-Git: https://salsa.debian.org/python-team/packages/scalene.git

## scalene 1.5.51

=== debian/changelog ===
scalene (1.5.51-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 15:03:00 +0000

scalene (1.5.51-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: Use libjs-bootstrap5 instead of libjs-bootstrap4 as binary
    dependency (Closes: #1088597).
    - run wrap-and-sort.

 -- Emmanuel Arias <eamanu@debian.org>  Mon, 17 Mar 2025 20:25:22 -0300

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Emmanuel Arias <eamanu@debian.org>,
-Build-Depends: cython3,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               cython3,
                help2man,
                pybuild-plugin-pyproject,
                python3-all-dev,
@@ -26,7 +26,7 @@
 
 Package: python3-scalene
 Architecture: any
-Depends: libjs-bootstrap4,
+Depends: libjs-bootstrap5,
          libjs-jquery,
          ${misc:Depends},
          ${python3:Depends},

## scalene 1.5.54

=== Makefile ===
--- 
+++ 
@@ -20,10 +20,13 @@
 mypy:
 	-mypy $(PYTHON_SOURCES)
 
-format: black clang-format
+format: black isort clang-format
 
 clang-format:
 	-clang-format -i $(C_SOURCES) --style=google
+
+isort:
+	-isort $(PYTHON_SOURCES)
 
 black:
 	-black -l 79 $(PYTHON_SOURCES)

=== requirements.txt ===
--- 
+++ 
@@ -1,13 +1,12 @@
 astunparse>=1.6.3; python_version < '3.9'
-cloudpickle==2.2.1
+cloudpickle>=2.2.1
 Cython>=0.29.28
-git+https://github.com/plasma-umass/crdp.git#egg=crdp
 ipython>=8.10
-Jinja2==3.0.3
-lxml==5.1.0
+Jinja2>=3.0.3
+lxml>=5.1.0
 packaging>=24
 psutil>=5.9.2
-pyperf==2.0.0
+pyperf>=2.0.0
 rich>=10.7.0
 setuptools>=65.5.1
 nvidia-ml-py>=12.555.43; platform_system !='Darwin'

=== vendor/Heap-Layers/examples/kingsley/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(kingsley LANGUAGES CXX)

# Set C++14 standard
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable optimization with debugging symbols
set(CMAKE_BUILD_TYPE RelWithDebInfo)
# set(CMAKE_BUILD_TYPE Debug)

# Generate position-independent code; required for shared libraries on many platforms
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Common definitions
add_definitions(-DNDEBUG -D_REENTRANT=1)

# Include directories
include_directories(. ../.. ../../util)

include(FetchContent)
FetchContent_Declare(
  printf
  GIT_REPOSITORY https://github.com/emeryberger/printf.git
  GIT_TAG        master
)
FetchContent_MakeAvailable(printf)
include_directories(${printf_SOURCE_DIR})

set(UNIX_SOURCES
  ../../wrappers/gnuwrapper.cpp
  libkingsley.cpp
  ${printf_SOURCE_DIR}/printf.cpp
)

set(MACOS_SOURCES
  ../../wrappers/macwrapper.cpp
  libkingsley.cpp
  ${printf_SOURCE_DIR}/printf.cpp
)

if(APPLE)
  set(ALL_SOURCES ${MACOS_SOURCES})
else()
  set(ALL_SOURCES ${UNIX_SOURCES})
endif()

# Create shared library
add_library(kingsley SHARED ${ALL_SOURCES})

# Let CMake handle platform-specific library settings
set_target_properties(kingsley PROPERTIES 
    VERSION 1.0.0
    SOVERSION 1)

# Add threading support if needed
find_package(Threads)
if(Threads_FOUND)
    target_link_libraries(kingsley Threads::Threads)
endif()

=== debian/changelog ===
scalene (1.5.54-2) unstable; urgency=medium

  * Team upload.
  * Allow stderr from autopkgtests, since scalene now warns on some
    architectures.

 -- Colin Watson <cjwatson@debian.org>  Thu, 04 Sep 2025 02:45:03 +0100

scalene (1.5.54-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Thu, 04 Sep 2025 01:52:00 +0100

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
                python3-rich,
                python3-setuptools,
                python3-setuptools-scm,
-               python3-wheel,
 Standards-Version: 4.7.0
 Homepage: https://github.com/plasma-umass/scalene
 Vcs-Browser: https://salsa.debian.org/python-team/packages/scalene

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,5 @@
 	set -e; for pyver in $(PYVERS); do \
 		abitag=.$$(python$$pyver -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
 		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/libscalene$$abitag.so; \
-		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/crdp.abi3.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/crdp$$abitag.so; \
 		mv $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/get_line_atomic.abi3.so $(DESTDIR)/usr/lib/python$$pyver/dist-packages/scalene/get_line_atomic$$abitag.so; \
 	done

=== debian/tests/control ===
Tests: simpletest
Depends:
 python3-all,
 @
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://pypi.debian.net/scalene/scalene-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
